#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <pthread.h>
#include <signal.h>
#include <memory.h>

#include "RStest.h"

int debug = 0;

unsigned char packet[BUFFERSIZE];
unsigned char response[BUFFERSIZE];


int main(int argc, char *argv[])
{
	system("clear");
	
	TestCOM(COM1,COM3);
	TestCOM(COM3,COM1);
		
exit(0);
}

int TestCOM(int PortA, int PortB)
{
	int i, errors = 0, percent;
	struct ser_conf Ser1;

	void *tretr, *tretw; 

	pthread_t COMRthread;
	pthread_t COMWthread;
	
	if(PortA == PortB){
		fprintf(stderr,"Ports must be different");
		return 0;
	}
	
	bzero(&packet, BUFFERSIZE);
	bzero(&response, BUFFERSIZE);
	
	Ser1.SerCFlags = 0;
	Ser1.SerCFlags = B115200 ;
	Ser1.SerCFlags |= CS8;
	Ser1.SerIFlags = 0;

	if(com_Init(PortB, &Ser1)){
			pthread_create(&COMRthread,
			       NULL,
			       (pthread_startroutine_t)COM_read_thread,
			       (void *) PortB);
		} else {
			fprintf(stderr,"Could not create COM%d read thread \n\n", PortB+1);
			return 0; 
		}
	
		if(com_Init(PortA, &Ser1)){
			pthread_create(&COMWthread,
			       NULL,
			       (pthread_startroutine_t)COM_write_thread,
			       (void *) PortA);
		} else {
			fprintf(stderr,"Could not create COM%d write thread \n\n",PortA+1);
			return 0; 
		}
	
	pthread_join(COMWthread, &tretw);
	pthread_join(COMRthread, &tretr);
	
	if((int)tretw == -1) {
		fprintf(stderr,"Data -> COM%d -- failed\n\n",PortA+1);
		com_Uninit(PortA);
		com_Uninit(PortB);
		return 0;
		}
		
	fprintf(stderr,"Data -> COM%d -- success\n",PortA+1);
	
	if((int)tretr == 0){
		fprintf(stderr,"COM%d -> Data -- failed\n\n",PortB+1);
		com_Uninit(PortA);
		com_Uninit(PortB);
		return 0;
		}

	if((int)tretr != (int)tretw){ 
	fprintf(stderr,"COM%d -> Data -- data received not the same length\n\n",PortB+1);
	com_Uninit(PortA);
	com_Uninit(PortB);
	return 0;
	}

	
	for(i =0; i< BUFFERSIZE; i++)
	{
	//printf("%02X %02X\n", packet[i], response[i]);
	if(packet[i] != response[i]) errors++;
	}
	
	if(!errors) fprintf(stderr, "COM%d -> Data -- success\n",PortB+1);
	percent = 100*(BUFFERSIZE - errors)/BUFFERSIZE;
	fprintf(stderr, "%d errors -- %d%c data received -- %d bytes\n",errors, percent,'%',(int)tretr);
	fprintf(stderr,"--------------------------------------------\n");

	com_Uninit(PortA);
	com_Uninit(PortB);
		
return 1;
}
