
#include <stdio.h>
#include <stdarg.h>
#include <memory.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>

#include "libnpe.h"

#define ADC_FACT	((2.5*(220+22))/22)

static void alrmhndl( int i )
{
    __u16	val = 0;
    __u8	chn;

    DebugMSG(DEBUG_ERR, "ADC readout:\n");

    for(chn = 0; chn < 8; chn++ )
    {
	ads7828_read( ADS7828_ADDR0, chn, &val );
        DebugMSG(DEBUG_ERR, "\tchnl %d voltage = %.2f V\n", chn, (val * ADC_FACT) / 4095);
    }
}

//----------------------------------------------------------------
// Function :   main
// Notes    :
// History  :
//----------------------------------------------------------------

int main(int argc, char *argv[])
{
	signal( SIGALRM, alrmhndl );
	
	ualarm( 500000, 500000 );
	
	while(1)
	sleep(10);

        exit(0);
}
