
#include <stdio.h>
#include <memory.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>

#include "libnpe.h"

int ads7828_read(__u16 addr, __u8 chnl, __u16 * val)
{
	__u8 				buf1[1] = {0x8C+((chnl<<4)&0x70)};
	__u8 				buf2[2] = {0,0};
	struct i2c_msg			i2c_msgs[2] = 
	{
	    {(addr>>1),0,1,buf1},
	    {(addr>>1),1,2,buf2}
	};
	struct i2c_rdwr_ioctl_data	i2c_ctrl =
	{
	    i2c_msgs, 2
	};
	int 				fd;
	
    	if((fd = open("/dev/i2c-0", O_RDWR)) < 0){
		DebugMSG(DEBUG_ERR, "i2c: Error opening /dev/i2c\n");
		return -1;
	}

	ioctl(fd,I2C_TIMEOUT,10);
	ioctl(fd,I2C_RETRIES,2);
	
	if( ioctl(fd,I2C_RDWR,(__u32)&i2c_ctrl) < 0 ){
		DebugMSG(DEBUG_ERR, "i2c: RW error\n");

		close(fd);
		return -1;
	}

	close(fd);

	*val = ((buf2[0]<<8) + buf2[1]) & 0x0FFF;

	return 0;
}

