
#ifndef __NPE_H__
  #define __NPE_H__

/* Debug constants */
#define DEBUG_FRAME             0x0001
#define DEBUG_STATUS            0x0002
#define DEBUG_FIELD             0x0004
#define DEBUG_ERR               0x0008
#define DEBUG_TIME              0x0010
#define DEBUG_INIT              0x0020

/* Debug settings */
#define DEBUG
#define DEBUG_ALL               (DEBUG_STATUS | DEBUG_ERR)
#define DEBUG_LEVEL             DEBUG_ALL

#ifdef DEBUG
#define DebugMSG(x, y, args...) if(x & DEBUG_LEVEL) printf(y, ##args)
#else
#define DebugMSG(x, y, args...)
#endif

#include "gpio.h"
#include "outio.h"
#include "pcf8583.h"
#include "uart.h"
#include "ads7828.h"

#endif

