
#ifndef __UART_H__
  #define __UART_H__

/* Port Codes */
#define COM1            0
#define COM2            1
#define COM3            2
#define COM4            3

/* Baud Rate Codes */
#define Baud19200       B19200          //!<
#define Baud9600        B9600           //!<
#define Baud4800        B4800           //!<
#define Baud2400        B2400           //!<
#define Baud1200        B1200           //!<

/* Parity Codes */
#define NoParity        0               //!<
#define OddParity       1               //!<
#define EvenParity      2               //!<

/* Stop Bit Codes */
#define OneStopBit      0               //!<
#define TwoStopBits     1               //!<

/* Word Length Codes */
#define WordLength5     CS5
#define WordLength6     CS6
#define WordLength7     CS7
#define WordLength8     CS8

int           com_Init    ( unsigned char Port, unsigned long BRate, unsigned char Len, unsigned char Par, unsigned char Stop );
void          com_Uninit  ( unsigned char Port );
short int     com_RxStat  ( unsigned char Port );
void          com_Flush   ( unsigned char Port );
unsigned char com_GetChar ( unsigned char Port );
int           com_PutChar ( unsigned char Port, unsigned char c );
void          com_TxWait  ( unsigned char Port );

#endif
