/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf,v 1.7 2003/04/08 14:57:04 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "npeMIB.h"

#include "libnpe.h"

/** Initializes the npeMIB module */
void
init_npeMIB(void)
{
    static oid inp0_oid[] = { 1,3,6,1,4,1,9991,1,1 };
    static oid inp1_oid[] = { 1,3,6,1,4,1,9991,1,2 };
    static oid out0_oid[] = { 1,3,6,1,4,1,9991,2,1 };

  DEBUGMSGTL(("npeMIB", "Initializing\n"));

    netsnmp_register_scalar(
        netsnmp_create_handler_registration("inp0", handle_inp0,
                               inp0_oid, OID_LENGTH(inp0_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("inp1", handle_inp1,
                               inp1_oid, OID_LENGTH(inp1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("out0", handle_out0,
                               out0_oid, OID_LENGTH(out0_oid),
                               HANDLER_CAN_RWRITE
        ));
}

int
handle_inp0(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int  val;
    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
	    val = io_port_read( 0 );
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                                     (u_char *) &val /* XXX: a pointer to the scalar's data */,
                                     sizeof(val) /* XXX: the length of the data in bytes */);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_inp1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int  val;
    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
	    val = port_pin_operation( PORT_PIOB, 0, '=' );
	    val &= 0x3C2;
	    val = (val &0x2) ? (val>>5)+1 : (val>>5);
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                                     (u_char *) &val /* XXX: a pointer to the scalar's data */,
                                     sizeof(val) /* XXX: the length of the data in bytes */);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_out0(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
	    {
		int fd = pcf8583_open( PCF8583_ADDR0 );		
		char r = 0;
		int  val;
		if( pcf8583_reg_read( fd, 16, &r ) == 0 )
		{
		    pcf8583_close( fd );				      
		}	
		val = r;			     
        	snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
            	                        (u_char *) &val /* XXX: a pointer to the scalar's data */,
                                        sizeof(val) /* XXX: the length of the data in bytes */);
	    }				
            break;

        /*
         * SET REQUEST
         *
         * multiple states in the transaction.  See:
         * http://www.net-snmp.org/tutorial-5/toolkit/mib_module/set-actions.jpg
         */
        case MODE_SET_RESERVE1:
            break;

        case MODE_SET_RESERVE2:
            break;

        case MODE_SET_FREE:
            break;

        case MODE_SET_ACTION:	
	    {
		int fd = pcf8583_open( PCF8583_ADDR0 );		
		char val = *(requests->requestvb->val.integer) & 0xFF;
		if( pcf8583_reg_write( fd, 16, val ) == 0 )
		{
		    pcf8583_close( fd );				      
		}				     
        	if ( io_port_write( 0, val ) != 0 ) {
            	    netsnmp_set_request_error(reqinfo, requests, 1 );
        	}
	    }
            break;

        case MODE_SET_COMMIT:
            break;

        case MODE_SET_UNDO:
            break;

        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
