/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf,v 1.7 2003/04/08 14:57:04 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <signal.h>
#include "npe2MIB.h"

#include "libnpe.h"

#define NPE2_VERSION	"NPE2 version 1.0"
#define ADC_CHNLS	8
#define ADC_DC_FACT	0.0067155
#define ADC_AC_FACT	0.0285710

typedef struct
{
  __u16		val;
  int		tmp;
  int		cnt;
} t_adcchnl;

static t_adcchnl	adc_buffer[ADC_CHNLS];
static int		adc_start  = 1;
static int		adc_filter = 1;

static void adc_timer( int i )
{
    __u16	val = 0;
    __u8	chn;

    if( adc_start )
    {
	for(chn = 0; chn < ADC_CHNLS; chn++ )
	{
	    if( ads7828_read( ADS7828_ADDR0, chn, &val ) == 0 )
	    {
		adc_buffer[chn].tmp += val;
		if( ++adc_buffer[chn].cnt >= adc_filter )
		{		
		    adc_buffer[chn].val = adc_buffer[chn].tmp / adc_buffer[chn].cnt;
		    adc_buffer[chn].tmp = 0;
		    adc_buffer[chn].cnt = 0;
		}
	    }
	}
    }
    else
    {
	memset( (char*)&adc_buffer, 0, sizeof(adc_buffer) );
    }
}

/** Initializes the npe2MIB module */
void
init_npe2MIB(void)
{
    static oid statVer_oid[] = { 1,3,6,1,4,1,28983,1,1 };
    static oid statTime_oid[] = { 1,3,6,1,4,1,28983,1,2 };
    static oid inp1_oid[] = { 1,3,6,1,4,1,28983,2,1 };
    static oid inp2_oid[] = { 1,3,6,1,4,1,28983,2,2 };
    static oid inp3_oid[] = { 1,3,6,1,4,1,28983,2,3 };
    static oid inp4_oid[] = { 1,3,6,1,4,1,28983,2,4 };
    static oid inp5_oid[] = { 1,3,6,1,4,1,28983,2,5 };
    static oid out1_oid[] = { 1,3,6,1,4,1,28983,3,1 };
    static oid out2_oid[] = { 1,3,6,1,4,1,28983,3,2 };
    static oid out3_oid[] = { 1,3,6,1,4,1,28983,3,3 };
    static oid out4_oid[] = { 1,3,6,1,4,1,28983,3,4 };
    static oid out5_oid[] = { 1,3,6,1,4,1,28983,3,5 };
    static oid out6_oid[] = { 1,3,6,1,4,1,28983,3,6 };
    static oid adcStart_oid[] = { 1,3,6,1,4,1,28983,4,1 };
    static oid adcFilter_oid[] = { 1,3,6,1,4,1,28983,4,2 };
    static oid adcDC1_oid[] = { 1,3,6,1,4,1,28983,4,3 };
    static oid adcDC1volts_oid[] = { 1,3,6,1,4,1,28983,4,4 };
    static oid adcDC2_oid[] = { 1,3,6,1,4,1,28983,4,5 };
    static oid adcDC2volts_oid[] = { 1,3,6,1,4,1,28983,4,6 };
    static oid adcDC3_oid[] = { 1,3,6,1,4,1,28983,4,7 };
    static oid adcDC3volts_oid[] = { 1,3,6,1,4,1,28983,4,8 };
    static oid adcAC1_oid[] = { 1,3,6,1,4,1,28983,4,9 };
    static oid adcAC1volts_oid[] = { 1,3,6,1,4,1,28983,4,10 };

  DEBUGMSGTL(("npe2MIB", "Initializing\n"));

    {
	__u16	val;
	
	ads7828_read( ADS7828_ADDR0, 0, &val );
	ads7828_read( ADS7828_ADDR0, 0, &val );
    
	memset( (char*)&adc_buffer, 0, sizeof(adc_buffer) );
    
	signal( SIGALRM, adc_timer );
	ualarm( 100000, 100000 );
    }
    
    //
    //	System
    //
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("systemVersion", handle_statVer,
                               statVer_oid, OID_LENGTH(statVer_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("systemTime", handle_statTime,
                               statTime_oid, OID_LENGTH(statTime_oid),
                               HANDLER_CAN_RONLY
        ));
    //
    //	Inputs
    //
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("input1", handle_inp1,
                               inp1_oid, OID_LENGTH(inp1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("input2", handle_inp2,
                               inp2_oid, OID_LENGTH(inp2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("input3", handle_inp3,
                               inp3_oid, OID_LENGTH(inp3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("input4", handle_inp4,
                               inp4_oid, OID_LENGTH(inp4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("switch1", handle_inp5,
                               inp5_oid, OID_LENGTH(inp5_oid),
                               HANDLER_CAN_RONLY
        ));
    //
    //	Outputs
    //	
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("outputOC1", handle_out1,
                               out1_oid, OID_LENGTH(out1_oid),
                               HANDLER_CAN_RWRITE
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("outputOC2", handle_out2,
                               out2_oid, OID_LENGTH(out2_oid),
                               HANDLER_CAN_RWRITE
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("outputREL1", handle_out3,
                               out3_oid, OID_LENGTH(out3_oid),
                               HANDLER_CAN_RWRITE
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("outputREL2", handle_out4,
                               out4_oid, OID_LENGTH(out4_oid),
                               HANDLER_CAN_RWRITE
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("outputLED1", handle_out5,
                               out5_oid, OID_LENGTH(out5_oid),
                               HANDLER_CAN_RWRITE
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("outputLED2", handle_out6,
                               out6_oid, OID_LENGTH(out6_oid),
                               HANDLER_CAN_RWRITE
        ));
    //
    //	ADC
    //
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcStart", handle_adcStart,
                               adcStart_oid, OID_LENGTH(adcStart_oid),
                               HANDLER_CAN_RWRITE
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcFilter", handle_adcFilter,
                               adcFilter_oid, OID_LENGTH(adcFilter_oid),
                               HANDLER_CAN_RWRITE
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcDC1", handle_adcDC1,
                               adcDC1_oid, OID_LENGTH(adcDC1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcDC1volts", handle_adcDC1volts,
                               adcDC1volts_oid, OID_LENGTH(adcDC1volts_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcDC2", handle_adcDC2,
                               adcDC2_oid, OID_LENGTH(adcDC2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcDC2volts", handle_adcDC2volts,
                               adcDC2volts_oid, OID_LENGTH(adcDC2volts_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcDC3", handle_adcDC3,
                               adcDC3_oid, OID_LENGTH(adcDC3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcDC3volts", handle_adcDC3volts,
                               adcDC3volts_oid, OID_LENGTH(adcDC3volts_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcAC1", handle_adcAC1,
                               adcAC1_oid, OID_LENGTH(adcAC1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("adcAC1volts", handle_adcAC1volts,
                               adcAC1volts_oid, OID_LENGTH(adcAC1volts_oid),
                               HANDLER_CAN_RONLY
        ));
}

//
//	System Status
//

int handle_statVer	( netsnmp_mib_handler   	  *handler,
                          netsnmp_handler_registration 	  *reginfo,
                          netsnmp_agent_request_info      *reqinfo,
                          netsnmp_request_info            *requests)
{
    u_char	ver[] = NPE2_VERSION;

    switch(reqinfo->mode) {

        case MODE_GET:
    	    snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                            	     (u_char *) ver,
                            	     strlen(ver) );
            break;


        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int handle_statTime	( netsnmp_mib_handler   	  *handler,
                          netsnmp_handler_registration 	  *reginfo,
                          netsnmp_agent_request_info      *reqinfo,
                          netsnmp_request_info            *requests)
{
    u_char      *ts;
    time_t	t;

    switch(reqinfo->mode) {

        case MODE_GET:
	    t = time(NULL);
	    ts = ctime(&t);
    	    snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                            	     (u_char *) ts,
                            	     strlen(ts) );
            break;


        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

//
//	Inputs
//

static int handle_pinput( int inp, netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int  val;
    
    switch(reqinfo->mode) {

        case MODE_GET:
	    val = (io_port_read( 0 ) & (1<<inp)) ? 1 : 0;
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                                     (u_char *) &val /* XXX: a pointer to the scalar's data */,
                                     sizeof(val) /* XXX: the length of the data in bytes */);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

static int handle_binput( int inp, netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int  val;
    
    switch(reqinfo->mode) {

        case MODE_GET:
	    val = port_pin_operation( PORT_PIOB, inp, '?' );
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                                     (u_char *) &val /* XXX: a pointer to the scalar's data */,
                                     sizeof(val) /* XXX: the length of the data in bytes */);
            break;


        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_inp1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_pinput( 0, handler, reginfo, reqinfo, requests );
}
int
handle_inp2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_pinput( 1, handler, reginfo, reqinfo, requests );
}
int
handle_inp3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_binput( 6, handler, reginfo, reqinfo, requests );
}
int
handle_inp4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_binput( 7, handler, reginfo, reqinfo, requests );
}
int
handle_inp5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_binput( 1, handler, reginfo, reqinfo, requests );
}

//
//	Outputs
//

static int output_set( int out, char op )
{
    int 	fd = pcf8583_open( PCF8583_ADDR0 );		
    int		res = -1;
    char 	r;

    if( pcf8583_reg_read( fd, 16, &r ) == 0 )
    {
	switch(op)
	{
	    case '+':
	        r |= (1<<out);
		res = io_port_write( 0, r );
	    break;
	    case '-':
	        r &= ~(1<<out);
		res = io_port_write( 0, r );
	    break;
	    default:
	    break;
	};
	pcf8583_reg_write( fd, 16, r );
    }
    pcf8583_close( fd );
    
    return res;
}

static int output_get( int out, int * val )
{
    int 	fd = pcf8583_open( PCF8583_ADDR0 );		
    int		res = -1;
    char 	r;

    if( pcf8583_reg_read( fd, 16, &r ) == 0 )
    {
        *val = (r & (1<<out)) ? 1 : 0;
	res = 0;
    }
    pcf8583_close( fd );
    
    return res;
}

static int handle_output (int output,netsnmp_mib_handler *handler,
                          netsnmp_handler_registration 	 *reginfo,
                          netsnmp_agent_request_info     *reqinfo,
                          netsnmp_request_info           *requests)
{
    switch(reqinfo->mode) {

        case MODE_GET:
	    {
		int  val;
		if( output_get( output, &val ) != 0 )
		{
		  val = -1;
		}
    		snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
            	                         (u_char *) &val /* XXX: a pointer to the scalar's data */,
                                	 sizeof(val) /* XXX: the length of the data in bytes */);
	    }				
            break;

        case MODE_SET_RESERVE1:
            break;

        case MODE_SET_RESERVE2:
            break;

        case MODE_SET_FREE:
            break;

        case MODE_SET_ACTION:	
	    {
		char val = *(requests->requestvb->val.integer) & 0xFF;
		if( output_set( output, (val&1) ? '+' : '-' ) != 0 )
		{
            	    netsnmp_set_request_error(reqinfo, requests, SNMP_ERR_NOACCESS );
        	}
	    }
            break;

        case MODE_SET_COMMIT:
            break;

        case MODE_SET_UNDO:
            break;

        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_out1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_output( 0, handler, reginfo, reqinfo, requests );
}
int
handle_out2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_output( 1, handler, reginfo, reqinfo, requests );
}
int
handle_out3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_output( 2, handler, reginfo, reqinfo, requests );
}
int
handle_out4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_output( 3, handler, reginfo, reqinfo, requests );
}
handle_out5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_output( 6, handler, reginfo, reqinfo, requests );
}
handle_out6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_output( 7, handler, reginfo, reqinfo, requests );
}

//
//	ADC
//

int handle_adcStart 	 (netsnmp_mib_handler 		 *handler,
                          netsnmp_handler_registration 	 *reginfo,
                          netsnmp_agent_request_info     *reqinfo,
                          netsnmp_request_info           *requests)
{
    switch(reqinfo->mode) {

        case MODE_GET:
	    {
		int  val = adc_start;
    		snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
            	                	 (u_char *) &val,
                    	                 sizeof(val) );
	    }				
            break;

        case MODE_SET_RESERVE1:
            break;

        case MODE_SET_RESERVE2:
            break;

        case MODE_SET_FREE:
            break;

        case MODE_SET_ACTION:	
	    {
		adc_start = *(requests->requestvb->val.integer) & 1;
	    }
            break;

        case MODE_SET_COMMIT:
            break;

        case MODE_SET_UNDO:
            break;

        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int handle_adcFilter 	 (netsnmp_mib_handler 		 *handler,
                          netsnmp_handler_registration 	 *reginfo,
                          netsnmp_agent_request_info     *reqinfo,
                          netsnmp_request_info           *requests)
{
    switch(reqinfo->mode) {

        case MODE_GET:
	    {
		int  val = adc_filter;
    		snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
            	                	 (u_char *) &val,
                    	                 sizeof(val) );
	    }				
            break;

        case MODE_SET_RESERVE1:
            break;

        case MODE_SET_RESERVE2:
            break;

        case MODE_SET_FREE:
            break;

        case MODE_SET_ACTION:	
	    {
		int val = *(requests->requestvb->val.integer);
		if( (val >= 1) && (val <= 100) )
		{
		    adc_filter = val;
		}
		else
		{
            	    netsnmp_set_request_error(reqinfo, requests, SNMP_ERR_WRONGVALUE );
		}
	    }
            break;

        case MODE_SET_COMMIT:
            break;

        case MODE_SET_UNDO:
            break;

        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

static int handle_adc	( int chnl, double fact,
			  netsnmp_mib_handler             *handler,
                          netsnmp_handler_registration 	  *reginfo,
                          netsnmp_agent_request_info      *reqinfo,
                          netsnmp_request_info            *requests)
{
    switch(reqinfo->mode) {

        case MODE_GET:
	    {
		int val = 0;
		if( fact == 0 )
		{
    		    if( adc_start )
		    {
			val = adc_buffer[chnl].val;
		    }
        	    snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                    	                    (u_char *) &val,
                            	            sizeof(val) );
		}
		else
		{
		    u_char str[10];
    		    if( adc_start )
		    {
			val = adc_buffer[chnl].val;
		    }
		    sprintf( str, "%.1f V", val * fact );
    		    snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                            	    	    (u_char *) str,
                            	    	    strlen(str));
		}
	    }		
            break;


        default:
            /* we should never get here, so this is a really bad error */
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_adcDC1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_adc( 0, 0, handler, reginfo, reqinfo, requests );
}
int
handle_adcDC1volts(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_adc( 0, ADC_DC_FACT, handler, reginfo, reqinfo, requests );
}
int
handle_adcDC2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_adc( 1, 0, handler, reginfo, reqinfo, requests );
}
int
handle_adcDC2volts(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_adc( 1, ADC_DC_FACT, handler, reginfo, reqinfo, requests );
}
int
handle_adcDC3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_adc( 2, 0, handler, reginfo, reqinfo, requests );
}
int
handle_adcDC3volts(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_adc( 2, ADC_DC_FACT, handler, reginfo, reqinfo, requests );
}
int
handle_adcAC1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_adc( 7, 0, handler, reginfo, reqinfo, requests );
}
int
handle_adcAC1volts(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    return handle_adc( 7, ADC_AC_FACT, handler, reginfo, reqinfo, requests );
}

