
#include <stdio.h>
#include <stdarg.h>
#include <memory.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>

#include "libnpe.h"

static int fd;
static int st = 0;
static int sw;

void outctl( char out, char action )
{
    int fd = pcf8583_open( PCF8583_ADDR0 );		
    char r;
    if( pcf8583_reg_read( fd, 16, &r ) == 0 )
    {
	switch(action)
	{
	    case '+':
	        r |= (1<<out);
		io_port_write( 0, r );
	    break;
	    case '-':
	        r &= ~(1<<out);
		io_port_write( 0, r );
	    break;
	    default:
	    break;
	};
	pcf8583_reg_write( fd, 16, r );
    }
    pcf8583_close( fd );
}

void finish( void )
{
    int i = st;

//    DebugMSG(DEBUG_ERR, "%d\n",st);

    outctl( 7, '+' );
    
    close( fd );

    while( i-- )    
    {
	usleep( 200000 );
	outctl( 6, '-' );
	usleep( 200000 );
	outctl( 6, '+' );
    }
    
    if( st == 2 )
    {
	usleep( 200000 );
	outctl( 6, '-' );
    }

    exit( st );
}

static void swhndl( int i )
{
	i = port_pin_operation( PORT_PIOB, 1, '?' );
	
	if( i != sw )
	{
	  sw = i;
	  if( i )
	  {
	    finish();
	  }
	}
}

//----------------------------------------------------------------
// Function :   main
// Notes    :
// History  :
//----------------------------------------------------------------

int main(int argc, char *argv[])
{
	int flg, i;
	
	outctl( 6, '+' );
	outctl( 7, '+' );

        DebugMSG(DEBUG_ERR, "NPE: Startup wait...\n");
	
	usleep( 500000 );
	
	if((fd = open( "/dev/switch", O_RDONLY )) == -1 ){	
    	    DebugMSG(DEBUG_ERR, "sw: open error\n");
	    exit(-1);
	}

	sw = port_pin_operation( PORT_PIOB, 1, '?' );
	
	signal( SIGIO, swhndl );
	
	fcntl( fd, F_SETOWN, getpid() );
	flg = fcntl( fd, F_GETFL );
	fcntl( fd, F_SETFL, flg | FASYNC );
	
        st = 0;

	if( !sw )
	{
	  finish();
	}

	outctl( 7, '-' );
	i = 4 * 5;
	while( --i && sw )
	{
  	  outctl( 6, '-' );
	  usleep( 100000 );
  	  outctl( 6, '+' );
	  usleep( 100000 );
	}
	outctl( 7, '+' );

	if( sw )
	{
	  finish();
	}

	st = 1;
	i = 10 * 1;
	while( --i && !sw )
	{
  	  outctl( 6, '-' );
	  usleep( 500000 );
  	  outctl( 6, '+' );
	  usleep( 500000 );
	}
	st = 2;
	outctl( 7, '-' );

	while( 1 ) sleep( 1 );	
}
