
#include <stdio.h>
#include <stdarg.h>
#include <memory.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>

#include "libnpe.h"

#define PORT	1000

//----------------------------------------------------------------
// Function :   main
// Notes    :
// History  :
//----------------------------------------------------------------

int main(int argc, char *argv[])
{
	int soc;
	struct sockaddr_in server;
	struct sockaddr_in client;
	unsigned int clilen;
	char buf[1024];
	int len;

    if( fork() == 0 )
    {
        DebugMSG(DEBUG_ERR, "NPE lookup deamon\n");
	
	soc = socket( AF_INET, SOCK_DGRAM, 0 );
	
	bzero( &server, sizeof(server) );
	server.sin_family = AF_INET;
	server.sin_addr.s_addr = INADDR_ANY;
	server.sin_port = htons(PORT);
	
	bind( soc, (struct sockaddr*)&server, sizeof(server) );
	
	for(;;)
	{
	    clilen = sizeof(client);
	    len = recvfrom( soc, buf, 1024, 0, &client, &clilen );

//    	    DebugMSG(DEBUG_ERR, "NPE deamon '%s'\n",buf);

	    if( strncmp( buf, "Info", 4 ) == 0 )
	    {
	        buf[0] = 0;
	        sprintf( &buf[strlen(buf)], "NPE version 1.0" );
//	        sprintf( &buf[strlen(buf)], "IP=%s", inet_ntoa( server.sin_addr ) );
  		sendto( soc, buf, strlen(buf), 0, &client, clilen );	    
	    }
	    else if( strncmp( buf, "Ping", 4 ) == 0 )
	    {
	        buf[0] = 0;
	        sprintf( &buf[strlen(buf)], "OK" );
//	        sprintf( &buf[strlen(buf)], "IP=%s", inet_ntoa( server.sin_addr ) );
  		sendto( soc, buf, strlen(buf), 0, &client, clilen );	    
	    }	    
	}
	
	close( soc );

        DebugMSG(DEBUG_ERR, "UDP lookup deamon exit\n");
    }

    exit(0);
}
