
#include <stdio.h>
#include <stdarg.h>
#include <memory.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>

#include "libnpe.h"

static int fd;

static void swhndl( int i )
{
	__u16	val = 0;

	ads7828_read( ADS7828_ADDR0, 0, &val );

	read( fd, &i, sizeof(int) );

        DebugMSG(DEBUG_ERR, "Switch pressed %X %d\n", i, val);
}

static void alrmhndl( int i )
{
	read( fd, &i, sizeof(int) );

        DebugMSG(DEBUG_ERR, "Stat %X\n", i);
}

//----------------------------------------------------------------
// Function :   main
// Notes    :
// History  :
//----------------------------------------------------------------

int main(int argc, char *argv[])
{
	int flg;
	
        DebugMSG(DEBUG_ERR, "NPE Switch test\n");
	
	if((fd = open( "/dev/switch", O_RDONLY )) == -1 ){	
    	    DebugMSG(DEBUG_ERR, "sw: open error\n");
	    exit(-1);
	}
	
	signal( SIGALRM, alrmhndl );
	signal( SIGIO, swhndl );
	
	ualarm( 500000, 500000 );
	
	fcntl( fd, F_SETOWN, getpid() );
	flg = fcntl( fd, F_GETFL );
	fcntl( fd, F_SETFL, flg | FASYNC );
	
        DebugMSG(DEBUG_ERR, "NPE Switch wait 10s ...\n");

	while(1)
	sleep(10);

	close( fd );

        DebugMSG(DEBUG_ERR, "Switch test stop\n");
	
        exit(0);
}
